	org $1001-2
	dw  $1001
	
ptr = $D0
dst = $D2

ptr1	= $E0
ptr2	= $E2
ptr3	= $E4
ptr4	= $E6

syncvalue = $CB	; screen row
	
	dw nextln,0	; second word is line number
	db $9e
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
	sta $FF3F
	;
	ldx #$02
zp1	lda $00,x
	sta $4800,x
	inx
	bne zp1
	;
	; ---
	;
	lda #$40
	sta ptr1+1
	lda #$00
	sta ptr1
	tay
	ldx #$07
il1	sta (ptr1),y
	iny
	bne il1
	inc ptr1+1
	dex
	bpl il1
	;
	lda #$00
	sta ptr1
	sta ptr2
	lda #$08
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
l3	lda #$CB
l1	cmp $FF1D
	bne l1
	;
	ldx #25
l2	ldy #$00
	lda $FF19
	and #$7F
	sta (ptr1),y
	;
	lda #$A0
	sta (ptr2),y
	;
	lda ptr1
	clc
	adc #40
	sta ptr1
	sta ptr2
	lda ptr1+1
	adc #$00
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
	dex
	bne l2
	;
	; ---
	;
	lda ptr1
	sec
	sbc #$E7
	sta ptr1
	sta ptr2
	lda ptr1+1
	sbc #$03
	sta ptr1+1
	ora #$04
	sta ptr2+1
	;
	lda ptr1
	cmp #40
	bne l3
	;
	; ---
	;
	lda #$0B
	sta $FF06
	;
l4	ldx #$FA
	lda $FF07
	and #$40
	beq *+4
	ldx #$F5
	;
	cpx $FF1D	; 2 frame delay
	bne *-3
	cpx $FF1D
	beq *-3
	cpx $FF1D
	bne *-3
	cpx $FF1D
	beq *-3
	;
	lda $FF19
	and #$7F
	sec
	sbc #$10
	bpl l5
	lda #$00
l5	sta $FF19
	bne l4
	;
	; ---
	;
	lda #$3B	; turn graphics mode on
	sta $FF06
	;
	lda $FF07	; PAL/NTSC friendly
	and #$40
	ora #$08	; use $18 for multicolor
	sta $FF07
	;
	lda $FF12
	and #$03	; keep lowest 2 bits (sound)	
	ora #$08	; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #$40	; color map
	sta $FF14
	;
	lda #$00
	sta $FF19
	;
	; ---
	;
	jsr show_all
	jsr wait_50_frames
	jsr do_big_scroll
	jsr wait_50_frames
	jsr wipe_all
	;
	; ##############################################
	;
	;sei
	;
	lda #$CC
sn1	cmp $FF1D
	bne sn1
	;
	lda #$0B
	sta $FF06
	;
	ldx #$02
zp2	lda $4800,x
	sta $00,x
	inx
	bne zp2
	;
	lda #$18
	sta $D1
	lda #$00
	sta $1000
	sta $D0
	tay
wipe1	sta ($D0),y
	iny
	bne wipe1
	inc $D1
	bpl wipe1
	;
;	lda #$A2		; restore irq
;	sta $FF0A
;	asl $FF09
;	;        
;	lda #$B3
;	sta $FFFE
;	lda #$FC
;	sta $FFFF
	;
	lda #$08
	sta $FF14
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	lda #$0B
	sta $FF06
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	sta $FF3E
	;
	ldx #$0F	; reset basic colors
cp1	lda $E143,x
	sta $0113,x
	dex
	bpl cp1
	;
	ldx #$FF
	txs
	;
	cli
	;
	lda #$00
	sta $053B
	lda #$93
	jsr $FFD2
	;
	lda #$F8
sn2	cmp $FF1D
	bne sn2
	;
	lda #$1B
	sta $FF06
	lda #$01
	sta $FF15
	sta $FF19
	;
	; ---
	;
	lda #$01	; logical number
	ldx #$08	; device number (8=disk)
	ldy #$01	; secondary address
	jsr $FFBA	; KERNAL: SETLFS
	;
	lda #fname_end - fname
	ldx #fname & 255
	ldy #fname >> 8
	jsr $FFBD	; KERNAL: SETNAM (Set length and filename address)
	;
	lda #$00	; 0=load
	sta $90		; clear error byte just in case
	jsr $FFD5	; KERNAL: LOADSP (Load from file)
	;
	; --- check for error
	;
	jsr $FFB7	; READSS, find out the status
	cmp #$00	; zero should mean no error
	beq NOERROR
	cmp #$40	; for serial devices, $40 means EOF was reached
	beq NOERROR
	;
	; --- disk error
	;
	lda #$0F
	ldx #$08
	tay
	jsr $FFBA	; KERNAL: SETLFS (Set LA, FA, SA) - OPEN 15, 8, 15
	;
	lda #$00
	jsr $FFBD	; KERNAL: SETNAM - no filename
	;
	jsr $FFC0	; KERNAL: OPEN (Open logical file)
	;
	ldx #$0F
	jsr $FFC6	; KERNAL: CHKIN (Open channel in)
	;
	lda #$80	; read a maximum of 128 chars
	sta $D0
	;
er1	jsr $EC8B	; Read one char
	jsr $FFD2	; KERNAL: BSOUT (Output to channel) - PRINT
	cmp #$0D	; C/R means end of information
	beq er2
	;
	dec $D0		; keep track of the read length to avoid infinite loops
	bne er1
	;
er2	lda #$0F
	jsr $FFC3	; KERNAL: CLOSE (Close logical file)
	;
	lda #$71	; reset colors
	sta $FF15
	lda #$6E
	sta $FF19
	;
	jsr $FF4F
	db "COULD NOT LOAD MAIN PROGRAM."
	db 0
	;
	jmp $8003	; READY.
	;
NOERROR	lda #$01	; set BASIC vectors to $4000
	sta $2B
	lda #$40
	sta $2C
	;
	lda $9D		; copy load end address to BASIC vectors
	sta $2D
	sta $2F
	sta $31
	lda $9E
	sta $2E
	sta $30
	sta $32
	;
	lda #$80	; flag gfx area allocated
	sta $75
	lda #$03	; mode 3
	sta $65
	lda #$20
	sta $83
	;
	jsr $8BBE	; BASIC RUN command
	jmp $8BDC
	
fname
	db "HAUPTPRO*"
fname_end
	
wait_50_frames
	ldx #50
	lda #syncvalue
wf1	cmp $FF1D
	bne wf1
wf2	cmp $FF1D
	beq wf2
	;
	dex
	bpl wf1
	rts
	
show_all
	lda #$00
	sta ptr1
	sta ptr2
	sta ptr3
	sta ptr4
	lda #$18
	sta ptr1+1
	lda #$1C
	sta ptr2+1
	lda #$40
	sta ptr3+1
	lda #$44
	sta ptr4+1
	;
m0	lda $FF1D
	cmp #syncvalue
	bne m0
	;
	ldx #24
m2	ldy #$00
	lda (ptr1),y
	sta (ptr3),y
	lda (ptr2),y
	sta (ptr4),y
	;
	lda ptr1
	clc
	adc #$28
	sta ptr1
	sta ptr3
	bcc *+6
	inc ptr1+1
	inc ptr3+1
	;
	lda ptr2
	clc
	adc #$28
	sta ptr2
	sta ptr4
	bcc *+6
	inc ptr2+1
	inc ptr4+1
	;
	dex
	bpl m2
	;
	; --
	;
	lda ptr1
	sec
	sbc #$E7
	sta ptr1
	sta ptr3
	lda ptr1+1
	sbc #$03
	sta ptr1+1
	clc
	adc #($40-$18)
	sta ptr3+1
	;
	lda ptr2
	sec
	sbc #$E7
	sta ptr2
	sta ptr4
	lda ptr2+1
	sbc #$03
	sta ptr2+1
	clc
	adc #($40-$18)
	sta ptr4+1
	;
	lda ptr1
	cmp #$28
	bne m0
	;
	rts
	
wipe_all
	lda #$00
	sta ptr1
	sta ptr2
	lda #$40
	sta ptr1+1
	lda #$44
	sta ptr2+1
	;
w0	lda $FF1D
	cmp #syncvalue
	bne w0
	;
	ldx #24
w2	ldy #$00
	lda #$00
	sta (ptr1),y
	sta (ptr2),y
	;
	lda ptr1
	clc
	adc #$28
	sta ptr1
	bcc *+4
	inc ptr1+1
	;
	lda ptr2
	clc
	adc #$28
	sta ptr2
	bcc *+4
	inc ptr2+1
	;
	dex
	bpl w2
	;
	lda ptr1
	sec
	sbc #$E7
	sta ptr1
	lda ptr1+1
	sbc #$03
	sta ptr1+1
	;
	lda ptr2
	sec
	sbc #$E7
	sta ptr2
	lda ptr2+1
	sbc #$03
	sta ptr2+1
	;
	lda ptr1
	cmp #$28
	bne w0
	;
	rts
	
do_big_scroll
	lda #scrolltext & 255
	sta dst
	lda #scrolltext >> 8
	sta dst+1
	;
co3	lda #$A8
	sta ptr
	lda #$42
	sta ptr+1
	;
co2	lda $FF1D
	cmp #syncvalue
	bne co2
	;
co0	ldy #$27
co1	lda (ptr),y
	clc
	adc (dst),y
	sta (ptr),y
	dey
	bpl co1
	;
	lda dst
	clc
	adc #$92
	sta dst
	lda dst+1
	adc #$00
	sta dst+1
	;
	lda ptr
	clc
	adc #$28
	sta ptr
	lda ptr+1
	adc #$00
	sta ptr+1
	;
	lda ptr
	cmp #$c0
	bne co0
	;
	; ---
	;
	lda dst
	sec
	sbc #($92*7-1) & 255
	sta dst
	lda dst+1
	sbc #($92*7-1) >> 8
	sta dst+1
	;
	lda dst
	cmp #(st1-40) & 255
	bne co3
	;
	rts
	
scrolltext
	cmap " ",0
	cmap "[",$ef
	cmap "]",$11
st0	db "                                         [   ][ ]   [ ][ ][   ]    [ ][   ]  [   ] [  ]    [ ][   ] [    ]                                        "
st1	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ][ ]                                           "
	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ][ ]                                           "
	db "                                        [ ]   [ ]   [ ][ ][   ]    [ ][ ][ ][   ] [ ][ ]   [ ] [  ] [   ]                                         "
	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ]   [ ]                                        "
	db "                                        [ ]   [ ]   [ ][ ][ ][ ]   [ ][ ][ ][ ]   [ ][ ]   [ ]   [ ]   [ ]                                        "
	db "                                         [   ] [   ] [  ] [   ]    [ ][ ][ ][ ]    [  ]    [ ][   ] [   ]                                         "

	org $1800
	include "pic.asm"
	
;eof